<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfWSTaskModification ArrayType
 * @subpackage Arrays
 */
class ArrayOfWSTaskModification extends AbstractStructArrayBase
{
    /**
     * The WSTaskModification
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\WSTaskModification[]
     */
    public $WSTaskModification;
    /**
     * Constructor method for ArrayOfWSTaskModification
     * @uses ArrayOfWSTaskModification::setWSTaskModification()
     * @param \StructType\WSTaskModification[] $wSTaskModification
     */
    public function __construct(array $wSTaskModification = array())
    {
        $this
            ->setWSTaskModification($wSTaskModification);
    }
    /**
     * Get WSTaskModification value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\WSTaskModification[]|null
     */
    public function getWSTaskModification()
    {
        return isset($this->WSTaskModification) ? $this->WSTaskModification : null;
    }
    /**
     * This method is responsible for validating the values passed to the setWSTaskModification method
     * This method is willingly generated in order to preserve the one-line inline validation within the setWSTaskModification method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateWSTaskModificationForArrayConstraintsFromSetWSTaskModification(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfWSTaskModificationWSTaskModificationItem) {
            // validation for constraint: itemType
            if (!$arrayOfWSTaskModificationWSTaskModificationItem instanceof \StructType\WSTaskModification) {
                $invalidValues[] = is_object($arrayOfWSTaskModificationWSTaskModificationItem) ? get_class($arrayOfWSTaskModificationWSTaskModificationItem) : sprintf('%s(%s)', gettype($arrayOfWSTaskModificationWSTaskModificationItem), var_export($arrayOfWSTaskModificationWSTaskModificationItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The WSTaskModification property can only contain items of type \StructType\WSTaskModification, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set WSTaskModification value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\WSTaskModification[] $wSTaskModification
     * @return \ArrayType\ArrayOfWSTaskModification
     */
    public function setWSTaskModification(array $wSTaskModification = array())
    {
        // validation for constraint: array
        if ('' !== ($wSTaskModificationArrayErrorMessage = self::validateWSTaskModificationForArrayConstraintsFromSetWSTaskModification($wSTaskModification))) {
            throw new \InvalidArgumentException($wSTaskModificationArrayErrorMessage, __LINE__);
        }
        if (is_null($wSTaskModification) || (is_array($wSTaskModification) && empty($wSTaskModification))) {
            unset($this->WSTaskModification);
        } else {
            $this->WSTaskModification = $wSTaskModification;
        }
        return $this;
    }
    /**
     * Add item to WSTaskModification value
     * @throws \InvalidArgumentException
     * @param \StructType\WSTaskModification $item
     * @return \ArrayType\ArrayOfWSTaskModification
     */
    public function addToWSTaskModification(\StructType\WSTaskModification $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\WSTaskModification) {
            throw new \InvalidArgumentException(sprintf('The WSTaskModification property can only contain items of type \StructType\WSTaskModification, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->WSTaskModification[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\WSTaskModification|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\WSTaskModification|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\WSTaskModification|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\WSTaskModification|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\WSTaskModification|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string WSTaskModification
     */
    public function getAttributeName()
    {
        return 'WSTaskModification';
    }
}
